/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package expressiontree.operators.unary;

import apfloatextraclasses.ApfloatMatrixException;
import apfloatextraclasses.ApfloatMatrixMath;
import expressiontree.ExpressionTreeElement;
import expressiontree.operands.Matrix;
import expressiontree.operators.UnaryOperator;
import expressiontree.operands.NumberType;
import expressiontree.operators.IncompatibleNumberFormatException;

/**
 * A determináns operátorok osztálya.
 * @author Esta
 */
public class Determinant extends UnaryOperator {

    @Override
    public ExpressionTreeElement getValue() throws IncompatibleNumberFormatException {
        ExpressionTreeElement op1 = this.operands.get(0).getValue();
        if (op1 instanceof NumberType) {
            //Ha csak számot talál, akkor a számot adjuk vissza.
            return ((NumberType) op1);
        } else if (op1 instanceof Matrix) {
            try {
                Matrix m = (Matrix) op1;
                if (m.getCols() != m.getRows()) {
                    //Ha a mátrix nem négyzetes, esély sincs arra, hogy determinánst számoljak.
                    throw new IncompatibleNumberFormatException("ERROR_DET");
                }
                //Ha négyzetes mátrix, akkor meghatározzuk a determinánst.
                NumberType retValue = new NumberType(this.precision,false);
                retValue.setValue(ApfloatMatrixMath.determinant(m.getMatrixValues()).precision(this.precision));
                return retValue;
            } catch (ApfloatMatrixException ex) {
                throw new IncompatibleNumberFormatException(ex.getMessage());
            }
        } else { //Ez elvileg SOHA nem fordulhat elő.
            throw new IncompatibleNumberFormatException("ERROR_DET_UNKNOWN");
        }
    }

    @Override
    public String toText(boolean b) {
        if (b) {
            return "det()";
        } else {
            return "det ";
        }
    }

    @Override
    public String getLocalizedName() {
        return java.util.ResourceBundle.getBundle("languages/operators").getString("DET");
    }
}
